技术频道导航
HTML/CSS
.NET技术
IIS技术
PHP技术
Js/JQuery
Photoshop
Fireworks
服务器技术
操作系统
网站运营

赞助商

分类目录

赞助商

最新文章

搜索

win2012 IIS8.5 安装PHP教程,一些版本不能用

作者:admin    时间:2022-11-23 10:46:28    浏览:

因为一直用win2003+IIS6.0+PHP的环境,所以搭建PHP自认为非常熟悉了,但是最近在搭建win2012+IIS8.5+PHP的环境时,我遇到了一些问题,经过4个小时的折腾,终于搞定了,本文记录一些经验,可能不少朋友也会遇到与我相同的问题。

win2012安装PHP,一些版本不能用

一开始我使用的PHP版本是 PHP-5.2.4-Win32,参照win10手动安装PHP的方法,很快就安装完毕,并且测试PHP程序运行成功,注意,此时没有用到php.ini这个文件。但当我要启用某些扩展功能时,比如extension=php_curl.dll,要用到了php.ini,并把该文件复制到C:\Windows后,运行PHP文件竟然报错:500内部服务器错误。这让我知道,以前win2003+IIS6.0+PHP的搭建方法,在win2012系统不适用了!

是不是PHP版本太低了?我带着这个疑问,下载了 php-5.3.29-nts-Win32-VC9-x86,重新手动配置PHP环境,没用到php.ini时,测试PHP程序运行成功。之后启用某扩展功能,用到了php.ini,并把该文件复制到C:\Windows后,再次运行PHP文件,不再报错!如此看来,真是PHP版本问题,要用 php5.3 以上的版本才行。

我还发现,与win2003配置PHP环境不同,在win2012系统配置PHP,若使用curl扩展(其他扩展可能也一样),则修改 php.ini ,修改完重启IIS立即生效了,不用再把php.ini文件复制到 C:\WINDOWS\ ,也不要复制与扩展相关的文件如 libeay32.dllssleay32.dllC:\WINDOWS\SysWOW64\

注意问题

1、还须安装VC库组件

安装配置好 php-5.3.29-nts-Win32-VC9-x86 后,还需要在服务器安装VC9,VC9是指Microsoft Visual C++ 9.0 32位,是安装 Visual C++库的运行时组件,使用户能够在计算机上运行使用Visual C++开发的应用程序,必须安装了之后才能正常运行。

如果你安装的PHP是其他版本,如 php-7.4.33-nts-Win32-VC15-x86,那么配置后你还必须安装VC15,PHP才能正常运行。

总之是看PHP的文件名决定所须安装的是哪个VC版本库组件。

2、只能安装非线程安全的版本

PHP版本有很多,如:

php-5.3.29-nts-win32-VC9-x86.msi
php-5.3.29-nts-Win32-VC9-x86.zip
php-5.3.29-src.zip
php-5.3.29-win32-VC9-x86.msi
php-5.3.29-Win32-VC9-x86.zip

在搭建win2012+IIS8.5+PHP环境时,只能选择非线程安全的版本,即是文件名含“nts”的版本。

.msi是安装版,src.zip是源码包。我们都不使用,其他2个版本的区别是:

php-5.3.29-nts-Win32-VC9-x86.zip ,nts为Non Thread Safe非线程安全的版本。

php-5.3.29-Win32-VC9-x86.zip,这个为线程安全的版本。

同时PHP还有其他的版本,即x64的版本,但是x64版本是实验性质的,所以可以无视,直接使用x86版。

至于 Thead Safe(线程安全) 和 Non Thead Safe(非线程安全) ,由于IIS配置PHP时,使用的是FastCGI模块,而此模块是单线程执行的,因而不需要线程安全版本。

TS(线程安全)和NTS(非线程安全)之分

Windows版的PHP从版本5.2.1开始有Thread Safe(线程安全)和None Thread Safe(NTS,非线程安全)之分,这两者不同在于何处?到底应该用哪种?这里做一个简单的介绍。

从2000年10月20日发布的第一个Windows版的PHP3.0.17开始的都是线程安全的版本,这是由于与Linux/Unix系统是采用多进程的工作方式不同的是Windows系统是采用多线程的工作方式。如果在IIS下以CGI方式运行PHP会非常慢,这是由于CGI模式是建立在多进程的基础之上的,而非多线程。

一般我们会把PHP配置成以ISAPI的方式来运行,ISAPI是多线程的方式,这样就快多了。但存在一个问题,很多常用的PHP扩展是以Linux/Unix的多进程思想来开发的,这些扩展在ISAPI的方式运行时就会出错搞垮IIS。因此在IIS下CGI模式才是PHP运行的最安全方式,但CGI模式对于每个HTTP请求都需要重新加载和卸载整个PHP环境,其消耗是巨大的。

为了兼顾IIS下PHP的效率和安全,微软给出了FastCGI的解决方案。FastCGI可以让PHP的进程重复利用而不是每一个新的请求就重开一个进程。同时FastCGI也可以允许几个进程同时执行。这样既解决了CGI进程模式消耗太大的问题,又利用上了CGI进程模式不存在线程安全问题的优势。

因此,如果是使用ISAPI的方式来运行PHP就必须用Thread Safe(线程安全)的版本;而用FastCGI模式运行PHP的话就没有必要用线程安全检查了,用None Thread Safe(NTS,非线程安全)的版本能够更好的提高效率。

PHP官方上关于widows的版本有4个:VC9 x86 Non Thread Safe,VC9 x86 Thread Safe,VC6 x86 Non Thread Safe,VC6 x86 Thread Safe;那么有什么区别呢?

1、这是对windows系统中运行库依赖

PHP是用C语言开发的所以依赖VC库运行。

Visual C++ 2003 运行库(VC7)
Visual C++ 2005 运行库(VC8)
Visual C++ 2008 运行库(VC9)
Visual C++ 2010 运行库(VC10)
Visual C++ 2012 运行库(VC11)
Visual C++ 2013 运行库(VC12)

只有安装了相应的运行库才能运行PHP,如php5.5要求VC11的安装。

2、运行方式的不同

PHP有2中运行方式:ISAPI和FastCGI。

ISAPI执行方式是以DLL动态库的形式使用,可以在被用户请求后执行,在处理完一个用户请求后不会马上消失,所以需要进行线程安全检查,这样来提高程序的执行效率,所以如果是以ISAPI来执行PHP,建议选择Thread Safe版本;

而FastCGI执行方式是以单一线程来执行操作,所以不需要进行线程的安全检查,除去线程安全检查的防护反而可以提高执行效率,所以,如果是以FastCGI来执行PHP,建议选择Non Thread Safe版本。

对于apache服务器来说一般选择isapi方式,而对于nginx服务器则选择FastCGI方式。

相关文章

标签: IIS8.5  IIS  PHP  
x
  • 站长推荐